summaryrefslogtreecommitdiff
path: root/contrib
diff options
context:
space:
mode:
Diffstat (limited to 'contrib')
-rw-r--r--contrib/Makefile.am84
-rwxr-xr-xcontrib/ffmpeg-universal.sh130
2 files changed, 190 insertions, 24 deletions
diff --git a/contrib/Makefile.am b/contrib/Makefile.am
index 2eabf662a..8433d4ce8 100644
--- a/contrib/Makefile.am
+++ b/contrib/Makefile.am
@@ -49,50 +49,86 @@ disable_popular_codecs=--disable-decoder=cinepak --disable-decoder=flashsv --dis
--disable-decoder=wavpack --disable-decoder=wmav1 --disable-decoder=wmav2 --disable-decoder=adpcm_swf
endif
+configure_options =\
+ --disable-shared --enable-static --disable-demuxers --disable-muxers --disable-strip \
+ --enable-gpl --enable-pthreads --disable-ffmpeg --disable-ffserver --disable-ffplay
+
+disable_decoders =\
+ --disable-decoder=bmp --disable-decoder=cavs --disable-decoder=cljr --disable-decoder=dsicinvideo \
+ --disable-decoder=ffv1 --disable-decoder=ffvhuff --disable-decoder=gif --disable-decoder=mdec \
+ --disable-decoder=mpeg_xvmc --disable-decoder=mszh --disable-decoder=png --disable-decoder=rawvideo \
+ --disable-decoder=sp5x --disable-decoder=targa --disable-decoder=tiertexseqvideo --disable-decoder=tiff \
+ --disable-decoder=vmnc --disable-decoder=zlib --disable-decoder=dsicinaudio --disable-decoder=imc \
+ --disable-decoder=mp3adu --disable-decoder=mp3on4 --disable-decoder=mpc7 --disable-decoder=sonic \
+ --disable-decoder=ws_snd1 --disable-decoder=adpcm_adx --disable-decoder=adpcm_g726 --disable-decoder=dvbsub \
+ --disable-decoder=dvdsub --disable-decoder=theora --disable-decoder=aac --disable-decoder=mpeg4aac \
+ --disable-decoder=ac3 --disable-decoder=vorbis
+
+all_configure_options = $(configure_options) \
+ --disable-encoders $(dxr3encoder) \
+ --enable-encoders $(disable_uncommon_codecs) $(disable_popular_codecs) \
+ $(disable_decoders) \
+ --make="$(MAKE)" \
+ --cc="$(CC)"
+
ffmpeg/config.mak: $(srcdir)/ffmpeg/configure Makefile
+if MACOSX_UNIVERSAL_BINARY
+ export CFLAGS="$(VISIBILITY_FLAG)"; \
+ export FFMPEG_CONFIGURE_OPTIONS="$(all_configure_options)"; \
+ $(srcdir)/ffmpeg-universal.sh -configure "$(srcdir)/ffmpeg" $(UNIVERSAL_ARCHES)
+else
mkdir -p ffmpeg
cd ffmpeg; \
- $(srcdir)/ffmpeg/configure \
- --disable-shared --enable-static \
- --disable-encoders $(dxr3encoder) \
- --enable-encoders $(disable_uncommon_codecs) $(disable_popular_codecs) \
- --disable-decoder=bmp --disable-decoder=cavs --disable-decoder=cljr --disable-decoder=dsicinvideo \
- --disable-decoder=ffv1 --disable-decoder=ffvhuff --disable-decoder=gif --disable-decoder=mdec \
- --disable-decoder=mpeg_xvmc --disable-decoder=mszh --disable-decoder=png --disable-decoder=rawvideo \
- --disable-decoder=sp5x --disable-decoder=targa --disable-decoder=tiertexseqvideo --disable-decoder=tiff \
- --disable-decoder=vmnc --disable-decoder=zlib --disable-decoder=dsicinaudio --disable-decoder=imc \
- --disable-decoder=mp3adu --disable-decoder=mp3on4 --disable-decoder=mpc7 --disable-decoder=sonic \
- --disable-decoder=ws_snd1 --disable-decoder=adpcm_adx --disable-decoder=adpcm_g726 --disable-decoder=dvbsub \
- --disable-decoder=dvdsub --disable-decoder=theora --disable-decoder=aac --disable-decoder=mpeg4aac \
- --disable-decoder=ac3 --disable-decoder=vorbis \
- --disable-demuxers \
- --disable-muxers \
- --disable-strip \
- --make="$(MAKE)" \
- --cc="$(CC)" \
+ $(srcdir)/ffmpeg/configure $(all_configure_options) \
--extra-cflags="$(CFLAGS) $(VISIBILITY_FLAG) -fPIC -DPIC" \
- --extra-ldflags="$(LDFLAGS)" \
- --enable-gpl \
- --enable-pthreads \
- --disable-ffmpeg \
- --disable-ffserver \
- --disable-ffplay; \
+ --extra-ldflags="$(LDFLAGS)"; \
cd ..
+endif
ffmpeg/libavutil/libavutil.a: ffmpeg/config.mak
+if MACOSX_UNIVERSAL_BINARY
+ export MAKE="$(MAKE)"; \
+ $(srcdir)/ffmpeg-universal.sh -avutil "$(srcdir)/ffmpeg" $(UNIVERSAL_ARCHES)
+else
$(MAKE) -C ffmpeg/libavutil libavutil.a
+endif
ffmpeg/libavcodec/libavcodec.a: ffmpeg/config.mak
+if MACOSX_UNIVERSAL_BINARY
+ export MAKE="$(MAKE)"; \
+ $(srcdir)/ffmpeg-universal.sh -avcodec "$(srcdir)/ffmpeg" $(UNIVERSAL_ARCHES)
+else
$(MAKE) -C ffmpeg/libavcodec libavcodec.a
+endif
ffmpeg/libpostproc/libpostproc.a: ffmpeg/config.mak
+if MACOSX_UNIVERSAL_BINARY
+ export MAKE="$(MAKE)"; \
+ $(srcdir)/ffmpeg-universal.sh -postproc "$(srcdir)/ffmpeg" $(UNIVERSAL_ARCHES)
+else
$(MAKE) -C ffmpeg/libpostproc libpostproc.a
+endif
clean-local:
+if MACOSX_UNIVERSAL_BINARY
+ for arch in $(UNIVERSAL_ARCHES); do \
+ $(MAKE) -C ffmpeg/$$arch clean; \
+ done
+ rm -f ffmpeg/libavcodec/libavcodec.a ffmpeg/libavutil/libavutil.a ffmpeg/libpostproc/libpostproc.a
+else
-$(MAKE) -C ffmpeg clean
+endif
distclean-local:
+if MACOSX_UNIVERSAL_BINARY
+ for arch in $(UNIVERSAL_ARCHES); do \
+ $(MAKE) -C ffmpeg/$$arch distclean; \
+ done
+ rm -f ffmpeg/config.mak ffmpeg/config.h
+ rm -f ffmpeg/libavcodec/libavcodec.a ffmpeg/libavutil/libavutil.a ffmpeg/libpostproc/libpostproc.a
+else
-$(MAKE) -C ffmpeg distclean
+endif
EXTRA_DIST = README.contrib ffmpeg-distfiles
diff --git a/contrib/ffmpeg-universal.sh b/contrib/ffmpeg-universal.sh
new file mode 100755
index 000000000..811aaa868
--- /dev/null
+++ b/contrib/ffmpeg-universal.sh
@@ -0,0 +1,130 @@
+#!/bin/sh
+
+function usage {
+ echo "usage: $0 <action> <source path> <arch list>"
+ echo "where: <action> is one of:"
+ echo " -configure do initial configuration for each architecture"
+ echo " -avcodec build libavcodec.a for each architecture"
+ echo " -avutil build libavutil.a for each architecture"
+ echo " -postproc build libpostproc.a for each architecture"
+ echo ""
+ echo "Configuration must be done before any library builds. Options to be passed"
+ echo "to ffmpeg's configure command-line should be passed in the environment"
+ echo "using the FFMPEG_CONFIGURE_OPTIONS environment variable."
+ exit 1
+}
+
+function run_configure {
+ local arch=$1
+ local ffmpeg_topbuilddir="$2"
+
+ # start over from scratch
+ rm -rf "$ffmpeg_topbuilddir"
+ mkdir -p "$ffmpeg_topbuilddir"
+ pushd "$ffmpeg_topbuilddir" > /dev/null 2>&1
+
+ # The Makefile should be passing FFMPEG_CONFIGURE_OPTIONS without passing
+ # any --extra-cflags or --extra-ldflags options. Both CFLAGS and LDFLAGS
+ # should be in the environment in addition to FFMPEG_CONFIGURE_OPTIONS.
+
+ local CROSS_OPTIONS=
+ local EXTRA_CFLAGS=
+ local EXTRA_LDFLAGS=
+
+ if test $HOST_ARCH != $arch; then
+ EXTRA_CFLAGS="$CFLAGS -isysroot /Developer/SDKs/MacOSX10.4u.sdk -arch $arch"
+ EXTRA_LDFLAGS="$LDFLAGS -isysroot /Developer/SDKs/MacOSX10.4u.sdk -arch $arch"
+ if test $arch = i386; then
+ FFMPEG_ARCH=x86_32
+ else
+ FFMPEG_ARCH=$arch
+ fi
+ CROSS_OPTIONS="--cross-compile --arch=$FFMPEG_ARCH"
+ fi
+
+ echo "$SOURCE_PATH/configure" $CROSS_OPTIONS $FFMPEG_CONFIGURE_OPTIONS \
+ --extra-cflags="$EXTRA_CFLAGS" \
+ --extra-ldflags="$EXTRA_LDFLAGS"
+ "$SOURCE_PATH/configure" $CROSS_OPTIONS $FFMPEG_CONFIGURE_OPTIONS \
+ --extra-cflags="$EXTRA_CFLAGS" \
+ --extra-ldflags="$EXTRA_LDFLAGS"
+ local retval=$?
+
+ popd > /dev/null 2>&1
+ if test $retval -ne 0; then
+ exit $retval
+ fi
+}
+
+if test x"$*" = x""; then
+ usage
+fi
+case "$1" in
+ -configure)
+ MODE=configure
+ ;;
+ -avcodec)
+ MODE=avcodec
+ ;;
+ -avutil)
+ MODE=avutil
+ ;;
+ -postproc)
+ MODE=postproc
+ ;;
+ *)
+ echo "Unrecognized mode: $1"
+ usage
+ ;;
+esac
+shift
+
+if test x"$1" = x""; then
+ echo "No source path specified!"
+ usage
+fi
+if test ! -d "$1"; then
+ echo "Source path $1 does not exist!"
+ exit 1
+fi
+SOURCE_PATH="$1"
+shift
+
+HOST_ARCH=`arch`
+UNIVERSAL_ARCHES=$*
+if test x"$UNIVERSAL_ARCHES" = x""; then
+ echo "No architecture(s) specified; using $HOST_ARCH only."
+ UNIVERSAL_ARCHES=$HOST_ARCH
+fi
+CONFIG_FILES=
+LIPO_CMDLINE="-create -output ffmpeg/lib$MODE/lib$MODE.a"
+for arch in $UNIVERSAL_ARCHES; do
+ ffmpeg_topbuilddir="ffmpeg/$arch"
+ LIPO_CMDLINE="$LIPO_CMDLINE -arch $arch $ffmpeg_topbuilddir/lib$MODE/lib$MODE.a"
+ case $MODE in
+ configure)
+ run_configure $arch "$ffmpeg_topbuilddir"
+ CONFIG_FILES="$CONFIG_FILES $ffmpeg_topbuilddir/config.h"
+ ;;
+ avcodec)
+ "$MAKE" -C "$ffmpeg_topbuilddir/libavcodec" libavcodec.a || exit $?
+ ;;
+ avutil)
+ "$MAKE" -C "$ffmpeg_topbuilddir/libavutil" libavutil.a || exit $?
+ ;;
+ postproc)
+ "$MAKE" -C "$ffmpeg_topbuilddir/libpostproc" libpostproc.a || exit $?
+ ;;
+ esac
+done
+
+if test "$MODE" != "configure"; then
+ mkdir -p ffmpeg/lib$MODE
+ lipo $LIPO_CMDLINE
+else
+ # Now that configuration is done, create config.h in the top-level ffmpeg
+ # directory. Pull out only what's needed by xine-lib, removing any possible
+ # platform conflicts
+ grep -h "define CONFIG_.*_DECODER" $CONFIG_FILES | uniq > ffmpeg/config.h
+ touch ffmpeg/config.mak
+fi